import React from "react";
import { FontAwesomeIcon } from "@fortawesome/react-fontawesome";
import { faPlus, faTrashAlt, faUpDown } from "@fortawesome/free-solid-svg-icons";
import { Utils } from "@react-awesome-query-builder-dev/ui";
var DragIcon = Utils.DragIcon;
var typeToIcon = {
  delGroup: faTrashAlt,
  delRuleGroup: faTrashAlt,
  delRule: faTrashAlt,
  addSubRuleSimple: faPlus,
  addSubRule: faPlus,
  addSubGroup: faPlus,
  addRule: faPlus,
  addGroup: faPlus,
  drag: faUpDown
};
export default (function (_ref) {
  var type = _ref.type;
  var icon = typeToIcon[type] && /*#__PURE__*/React.createElement(FontAwesomeIcon, {
    icon: typeToIcon[type]
  }) || null;
  if (!icon && type === "drag") {
    icon = /*#__PURE__*/React.createElement(DragIcon, null);
  }
  return icon;
});